"use strict";

(function () {

  var async = require('async');
  var chalk = require('chalk');
  var childProcess = require('child_process');
  var fs = require('fs');

  var fsp = require('../../utils/fs');
  var path = require('../../utils/path.js');

  module.exports = function (options) {

    console.log('\u5F00\u59CB\u5B89\u88C5 ' + options.cmd + ' ...');

    var repo = options.cmd;
    var efesdir = path.join(__dirname, '..', '..', '..');
    var condir = path.join(efesdir, 'dist', 'commands', repo, 'command.json');

    var _cmd = fsp.readJSONSync(condir);

    if (_cmd) {

      if (_cmd.installed === true && !options.force) {
        console.log('\n' + chalk.green('\u6B64\u547D\u4EE4\u5DF2\u7ECF\u5B89\u88C5\u6210\u529F\uFF0C\u8BF7\u8FD0\u884C efes install -f --cmd ' + repo + ' \u8FDB\u884C\u5F3A\u5236\u91CD\u65B0\u5B89\u88C5\u3002') + '\n');
        process.exit(1);
      }

      try {

        if (_cmd.packages.length > 0) {

          _cmd.packages.some(function (_repo) {

            var cmd = 'npm install ' + _repo + ' --save';

            childProcess.execSync(cmd, {
              cwd: efesdir,
              stdio: 'inherit'
            });
          });
        }
      } catch (e) {
        console.log('\n' + chalk.red('安装失败！') + '\n');
        process.exit(1);
      }

      _cmd.installed = true;

      var a = fsp.writeJSONSync(condir, _cmd);

      console.log('\n' + chalk.green('安装成功！') + '\n');
    } else {
      console.log('\n' + chalk.red('\u672A\u627E\u5230 ' + repo + ' \u7684\u914D\u7F6E\u6587\u4EF6\uFF0C\u65E0\u6CD5\u5B89\u88C5\u6B64\u547D\u4EE4\u3002') + '\n');
    }
  };
})();